diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/midi/midi.c oss-v4.1test0-070624-src-gpl/kernel/framework/midi/midi.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/midi/midi.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/midi/midi.c	Tue Jun 26 22:19:44 2007
@@ -576,13 +576,13 @@
  */
   oss_native_word flags;
   oss_midi_client_t *client;
-  int ok, err = -EBUSY;
+  int ok, err = RETERR(EBUSY);
   int mode = file->mode & O_ACCMODE;
 
   char *cmd;
 
   if (dev < 0 || dev >= num_mididevs)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   /* 
    * Don't allow read only access on playback only devices.
@@ -591,7 +591,7 @@
    */
   if ((mode == OPEN_READ) && !(midi_devs[dev]->flags & MFLAG_INPUT))
     {
-      return -EACCES;
+      return RETERR(EACCES);
     }
 
   /*
@@ -599,14 +599,14 @@
    */
   if ((mode & OPEN_WRITE) && !(midi_devs[dev]->flags & MFLAG_OUTPUT))
     {
-      return -EACCES;
+      return RETERR(EACCES);
     }
 
   if (!midi_devs[dev]->enabled)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (midi_devs[dev]->unloaded)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   MUTEX_ENTER_IRQDISABLE (midi_mutex, flags);
 
@@ -670,7 +670,7 @@
 	  midi_devs[dev]->open_mode = 0;
 	  client->open_mode = 0;
 	  client->mididev = NULL;
-	  return -ENOMEM;
+	  return RETERR(ENOMEM);
 	}
     }
 
@@ -689,7 +689,7 @@
 	  midi_devs[dev]->open_mode = 0;
 	  client->open_mode = 0;
 	  client->mididev = NULL;
-	  return -ENOMEM;
+	  return RETERR(ENOMEM);
 	}
 
 /*
@@ -943,7 +943,7 @@
   mididev = client->mididev;
 
   if (mididev == NULL)
-    return -EBUSY;
+    return RETERR(EBUSY);
 
   MUTEX_ENTER_IRQDISABLE (mididev->mutex, flags);
 
@@ -960,21 +960,21 @@
 	{
 	  MUTEX_EXIT_IRQRESTORE (mididev->mutex, flags);
 	  cmn_err (CE_WARN, "Too short MIDI write (no header)\n");
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
 
       MUTEX_EXIT_IRQRESTORE (mididev->mutex, flags);
       if (uiomove (&hdr, sizeof (midi_packet_header_t), UIO_WRITE, buf) != 0)
 	{
 	  cmn_err (CE_WARN, "uiomove (header) failed\n");
-	  return -EFAULT;
+	  return RETERR(EFAULT);
 	}
 
       if (hdr.magic != MIDI_HDR_MAGIC)
 	{
 	  cmn_err (CE_WARN, "Bad MIDI write packet header (%04x)\n",
 		   hdr.magic);
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
       count -= sizeof (midi_packet_header_t);
       c += sizeof (midi_packet_header_t);
@@ -998,7 +998,7 @@
 	  MUTEX_EXIT_IRQRESTORE (mididev->mutex, flags);
 	  cmn_err (CE_CONT, "MIDI Output buffer %d doesn't drain %d/%d\n",
 		   mididev->dev, c, count);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       if (l > MIDI_PAYLOAD_SIZE)
@@ -1008,7 +1008,7 @@
 	   midi_queue_alloc_record (mididev->out_queue, &targetbuf, l,
 				    &hdr)) < 0)
 	{
-	  if (ret == -ENOSPC)	/* Buffers full */
+	  if (ret == RETERR(ENOSPC))	/* Buffers full */
 	    {
 	      MDB (cmn_err (CE_CONT, "*** Buffers full ***\n"));
 	      tmout =
@@ -1019,7 +1019,7 @@
 		  MUTEX_EXIT_IRQRESTORE (mididev->mutex, flags);
 		  if (c > 0)
 		    return c;
-		  return -EIO;	/* Timeout - why */
+		  return RETERR(EIO);	/* Timeout - why */
 		}
 	      else
 		loops = 0;	/* Restart loop limiter */
@@ -1028,7 +1028,7 @@
 		{
 		  mididev->is_killed = 1;
 		  MUTEX_EXIT_IRQRESTORE (mididev->mutex, flags);
-		  return -EINTR;
+		  return RETERR(EINTR);
 		}
 
 	      if (loops > 95)
@@ -1054,7 +1054,7 @@
 	  if (uiomove (targetbuf, l, UIO_WRITE, buf) != 0)
 	    {
 	      cmn_err (CE_WARN, "uiomove (write) failed\n");
-	      return -EFAULT;
+	      return RETERR(EFAULT);
 	    }
 
 	  count -= l;
@@ -1085,14 +1085,14 @@
       if (max_bytes <= sizeof (*hdr))
 	{
 	  cmn_err (CE_WARN, "MIDI read too small for packet header\n");
-	  return -E2BIG;
+	  return RETERR(E2BIG);
 	}
 
       hdr->magic = MIDI_HDR_MAGIC;
       if (uiomove (hdr, sizeof (*hdr), UIO_READ, buf) != 0)
 	{
 	  cmn_err (CE_WARN, "uiomove (read) failed\n");
-	  return -EFAULT;
+	  return RETERR(EFAULT);
 	}
 
       l += sizeof (*hdr);
@@ -1102,12 +1102,12 @@
     c = max_bytes - l;
 
   if (c <= 0)
-    return -E2BIG;
+    return RETERR(E2BIG);
 
   if (uiomove (data, c, UIO_READ, buf) != 0)
     {
       cmn_err (CE_WARN, "uiomove (read) failed\n");
-      return -EFAULT;
+      return RETERR(EFAULT);
     }
 
   midi_queue_remove_chars (mididev->in_queue, c);
@@ -1138,7 +1138,7 @@
   mididev = client->mididev;
 
   if (mididev == NULL)
-    return -EBUSY;
+    return RETERR(EBUSY);
 
   MUTEX_ENTER_IRQDISABLE (mididev->mutex, flags);
 
@@ -1159,7 +1159,7 @@
   if (mididev->prech_timeout < 0)	/* Non blocking mode */
     {
       MUTEX_EXIT_IRQRESTORE (mididev->mutex, flags);
-      return -EWOULDBLOCK;
+      return RETERR(EWOULDBLOCK);
     }
 
   if (!oss_sleep
@@ -1176,7 +1176,7 @@
     {
       mididev->is_killed = 1;
       MUTEX_EXIT_IRQRESTORE (mididev->mutex, flags);
-      return -EINTR;
+      return RETERR(EINTR);
     }
 
   if ((c = midi_queue_get (mididev->in_queue, &data, count, &hdr)) < 0
@@ -1210,7 +1210,7 @@
 	{
 	  cmn_err (CE_WARN, "Invalid MIDI timer %d selected\n",
 		   mididev->timer_driver);
-	  return -ENXIO;
+	  return RETERR(ENXIO);
 	}
 
       if ((timer_dev =
@@ -1235,7 +1235,7 @@
       oss_timer_devs[timer_dev] == NULL)
     {
       cmn_err (CE_WARN, "Failed to allocate a timer instance\n");
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
 
 
@@ -1274,7 +1274,7 @@
       return err;
   mididev = client->mididev;
   if (mididev == NULL)
-    return -EBUSY;
+    return RETERR(EBUSY);
 
   dev = mididev->dev;
 
@@ -1283,7 +1283,7 @@
     case SNDCTL_MIDI_PRETIME:
       val = *arg;
       if (val < -1)
-	return -EINVAL;
+	return RETERR(EINVAL);
 
       if (val != -1)
 	val = (OSS_HZ * val) / 100;
@@ -1312,7 +1312,7 @@
 	  break;
 	  break;
 	default:
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
       mididev->mtc_timebase = val;
       mididev->mtc_t0 = GET_JIFFIES ();
@@ -1330,7 +1330,7 @@
       val = *arg;
       if (val != MIDI_MODE_TRADITIONAL && val != MIDI_MODE_TIMED
 	  && val != MIDI_MODE_TIMED_ABS)
-	return -EINVAL;
+	return RETERR(EINVAL);
       mididev->working_mode = val;
       *arg = val;
       if ((err = setup_working_mode (mididev)) < 0)
@@ -1345,7 +1345,7 @@
     case SNDCTL_MIDI_TIMEBASE:
       val = *arg;
       if (val < 1 || val > 1000)
-	return -EINVAL;
+	return RETERR(EINVAL);
       mididev->timebase = val;
       return setup_timebase (mididev);
       break;
@@ -1353,7 +1353,7 @@
     case SNDCTL_MIDI_TEMPO:
       val = *arg;
       if (val < 1 || val > 200)
-	return -EINVAL;
+	return RETERR(EINVAL);
       mididev->tempo = val;
       return setup_tempo (mididev);
       break;
@@ -1374,14 +1374,14 @@
   int err;
 
   if (dev < 0 || dev >= oss_num_midi_clients)
-    return -ENXIO;
+    return RETERR(ENXIO);
   client = oss_midi_clients[dev];
   if (client->mididev == NULL)
     if ((err = midi_mapper_autobind (dev, client->open_mode)) < 0)
       return err;
   mididev = client->mididev;
   if (mididev == NULL)
-    return -EIO;
+    return RETERR(EIO);
 
   if ((events & (POLLOUT | POLLWRNORM)) && (mididev->open_mode & OPEN_WRITE))
     {
@@ -1459,7 +1459,7 @@
 
   oss_native_word flags;
   oss_midi_client_t *client = NULL;
-  int ok, err = -EBUSY, d;
+  int ok, err = RETERR(EBUSY), d;
   int mode = file->mode & O_ACCMODE;
 
   MUTEX_ENTER_IRQDISABLE (midi_mutex, flags);
@@ -1492,14 +1492,14 @@
 	{
 	  cmn_err (CE_WARN, "Too many MIDI clients\n");
 	  MUTEX_EXIT_IRQRESTORE (midi_mutex, flags);
-	  return -ENXIO;
+	  return RETERR(ENXIO);
 	}
 
       if (client == NULL)
 	{
 	  cmn_err (CE_WARN, "Out of memory\n");
 	  MUTEX_EXIT_IRQRESTORE (midi_mutex, flags);
-	  return -ENOMEM;
+	  return RETERR(ENOMEM);
 	}
 
       memset (client, 0, sizeof (*client));
@@ -1614,7 +1614,7 @@
   if (midi_devs == NULL)
     {
       cmn_err (CE_WARN, "oss_install_mididev: Out of memory\n");
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
 
   for (i = 0; i < num_mididevs; i++)
@@ -1632,7 +1632,7 @@
       if (num_mididevs >= MAX_MIDI_DEV - 1)
 	{
 	  cmn_err (CE_WARN, "Too many MIDI devices in the system\n");
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       op = midi_devs[num_mididevs] = PMALLOC (osdev, sizeof (mididev_t));
@@ -1640,7 +1640,7 @@
 	{
 	  cmn_err (CE_WARN,
 		   "oss_install_mididev: Failed to allocate memory\n");
-	  return -ENOMEM;
+	  return RETERR(ENOMEM);
 	}
       memset (op, 0, sizeof (*op));
       curr_midi_dev = num_mididevs++;
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/midi/midi_mapper.c oss-v4.1test0-070624-src-gpl/kernel/framework/midi/midi_mapper.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/midi/midi_mapper.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/midi/midi_mapper.c	Tue Jun 26 22:19:44 2007
@@ -77,7 +77,7 @@
 			   "Failed to allocate MIDI input queue(2)\n");
 		  midi_devs[dev]->d->close (dev, mode);
 		  midi_devs[dev]->open_mode = 0;
-		  return -ENOMEM;
+		  return RETERR(ENOMEM);
 
 		}
 	    }
@@ -92,7 +92,7 @@
 			   "Failed to allocate MIDI output queue(2)\n");
 		  midi_devs[dev]->d->close (dev, mode);
 		  midi_devs[dev]->open_mode = 0;
-		  return -ENOMEM;
+		  return RETERR(ENOMEM);
 
 		}
 	    }
@@ -105,5 +105,5 @@
 	}
     }
 
-  return -EBUSY;
+  return RETERR(EBUSY);
 }
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/midi/midi_queue.c oss-v4.1test0-070624-src-gpl/kernel/framework/midi/midi_queue.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/midi/midi_queue.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/midi/midi_queue.c	Tue Jun 26 22:19:45 2007
@@ -189,13 +189,13 @@
   if (queue == NULL)
     {
       cmn_err (CE_WARN, "midi_queue_alloc_record: Queue==NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (len < 1 && hdr == NULL)	/* Nothing was given */
     {
       cmn_err (CE_WARN, "midi_queue_alloc_record: No data\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (len > MIDI_PAYLOAD_SIZE)
@@ -211,13 +211,13 @@
   if (next == queue->q_tail)
     {
       MUTEX_EXIT_IRQRESTORE (queue->mutex, flags);
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
 
   if (queue->avail < BUF_PREFIX_SIZE + len)
     {
       MUTEX_EXIT_IRQRESTORE (queue->mutex, flags);
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
 
   n = queue->q_head - queue->q_tail;
@@ -227,7 +227,7 @@
   if (n < 1)
     {
       MUTEX_EXIT_IRQRESTORE (queue->mutex, flags);
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
 
   if (queue->buf_tail > queue->buf_head)
@@ -258,7 +258,7 @@
 #endif
 	{
 	  MUTEX_EXIT_IRQRESTORE (queue->mutex, flags);
-	  return -ENOSPC;
+	  return RETERR(ENOSPC);
 	}
     }
 
@@ -267,7 +267,7 @@
       cmn_err (CE_CONT, "MIDI queue damaged (%d/%d/alloc)\n", queue->buf_head,
 	       QUEUE_BYTES);
       MUTEX_EXIT_IRQRESTORE (queue->mutex, flags);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (queue->buf_head + BUF_PREFIX_SIZE + len > QUEUE_BYTES)
@@ -278,7 +278,7 @@
       cmn_err (CE_CONT, "Avail=%d\n", avail);
       cmn_err (CE_CONT, "Required=%d\n", len + BUF_PREFIX_SIZE);
       MUTEX_EXIT_IRQRESTORE (queue->mutex, flags);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   ptr = queue->buffer + queue->buf_head;
@@ -317,7 +317,7 @@
 
   if (queue == NULL)
     {
-      return -EIO;
+      return RETERR(EIO);
     }
 #if 0
   {
@@ -332,7 +332,7 @@
     return 0;
 
   if (len > MIDI_PAYLOAD_SIZE)
-    return -E2BIG;
+    return RETERR(E2BIG);
 
 #if 1
   if (len == 1)
@@ -354,7 +354,7 @@
     {
       cmn_err (CE_CONT, "MIDI queue damaged (%d/%d/%d/put)\n",
 	       queue->buf_head, queue->buf_tail, QUEUE_BYTES);
-      return -EIO;
+      return RETERR(EIO);
     }
   return len;
 }
@@ -370,13 +370,13 @@
   *data = NULL;
 
   if (queue == NULL)
-    return -EIO;
+    return RETERR(EIO);
 
   if (queue->buf_head >= QUEUE_BYTES || queue->buf_tail >= QUEUE_BYTES)
     {
       cmn_err (CE_CONT, "MIDI queue damaged (%d/%d/%d/get)\n",
 	       queue->buf_head, queue->buf_tail, QUEUE_BYTES);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   MUTEX_ENTER_IRQDISABLE (queue->mutex, flags);
@@ -420,7 +420,7 @@
   *data = NULL;
 
   if (queue == NULL)
-    return -EIO;
+    return RETERR(EIO);
 
   MUTEX_ENTER_IRQDISABLE (queue->mutex, flags);
   if (queue->q_head == queue->q_tail)
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/midi/timers.c oss-v4.1test0-070624-src-gpl/kernel/framework/midi/timers.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/midi/timers.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/midi/timers.c	Tue Jun 26 22:19:45 2007
@@ -37,25 +37,25 @@
     {
       cmn_err (CE_WARN, "Incompatible timer driver version %d\n",
 	       driver_version);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (driver_size != sizeof (*op))
     {
       cmn_err (CE_WARN, "Incompatible timer driver size %d\n", driver_size);
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (oss_num_timer_drivers >= MAX_TIMER_DEV)
     {
       cmn_err (CE_WARN, "Too many timer drivers\n");
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
 
   if ((op = PMALLOC (osdev, sizeof (*op))) == NULL)
     {
       cmn_err (CE_WARN, "Out of memory (oss_install_timer)\n");
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
 
   memcpy (op, d, driver_size);
@@ -87,7 +87,7 @@
 /* TODO: Create a mutex for all timers */
 
   if (driver_dev < 0 || driver_dev >= oss_num_timer_drivers)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   drv = oss_timer_drivers[driver_dev];
 
@@ -98,7 +98,7 @@
 	       driver_dev, drv->max_instances);
 
       MUTEX_EXIT_IRQRESTORE (drv->mutex, flags);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
   drv->num_instances++;
   MUTEX_EXIT_IRQRESTORE (drv->mutex, flags);
@@ -108,7 +108,7 @@
       MUTEX_ENTER_IRQDISABLE (drv->mutex, flags);
       drv->num_instances--;
       MUTEX_EXIT_IRQRESTORE (drv->mutex, flags);
-      return -ENOMEM;
+      return RETERR(ENOMEM);
     }
   memset (tmr, 0, sizeof (*tmr));
 
@@ -130,7 +130,7 @@
 	  MUTEX_ENTER_IRQDISABLE (drv->mutex, flags);
 	  drv->num_instances--;
 	  MUTEX_EXIT_IRQRESTORE (drv->mutex, flags);
-	  return -EBUSY;
+	  return RETERR(EBUSY);
 	}
       num = oss_num_timers++;
     }
@@ -175,18 +175,18 @@
   oss_native_word flags;
 
   if (timer_dev < 0 || timer_dev >= oss_num_timers)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   tmr = oss_timer_devs[timer_dev];
   if (tmr == NULL)
     {
       cmn_err (CE_WARN, "tmr==NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
   if (tmr->d == NULL)
     {
       cmn_err (CE_WARN, "tmr->d==NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (tmr->d->attach_client != NULL)
@@ -350,11 +350,11 @@
   int err;
 
   if (timer_dev < 0 || timer_dev >= oss_num_timers)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   tmr = oss_timer_devs[timer_dev];
   if (tmr == NULL)
-    return -ENXIO;
+    return RETERR(ENXIO);
   tmr->pending_tempo = tempo;
 
   {
@@ -378,11 +378,11 @@
   int err;
 
   if (timer_dev < 0 || timer_dev >= oss_num_timers)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   tmr = oss_timer_devs[timer_dev];
   if (tmr == NULL || tmr->d->set_timebase == NULL)
-    return -ENXIO;
+    return RETERR(ENXIO);
   tmr->timebase = timebase;
   if ((err = tmr->d->set_timebase (timer_dev, timebase)) < 0)
     return err;
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/mixer/mixer.c oss-v4.1test0-070624-src-gpl/kernel/framework/mixer/mixer.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/mixer/mixer.c	Sun Jun 24 18:09:42 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/mixer/mixer.c	Tue Jun 26 22:19:45 2007
@@ -51,7 +51,7 @@
   mixer_info *info = (mixer_info *) arg;
 
   if (dev < 0 || dev >= num_mixers)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   strcpy (info->id, mixer_devs[dev]->id);
   strncpy (info->name, mixer_devs[dev]->name, 31);
@@ -75,13 +75,13 @@
   int ret;
 
   if (!(cmd & SIOC_OUT) && !(cmd & SIOC_IN))
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (arg == 0)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   if (((cmd >> 8) & 0xff) != 'M')	/* Not a mixer ioctl */
-    return -EINVAL;
+    return RETERR(EINVAL);
 #ifdef DO_TIMINGS
   {
     char tmp[128];
@@ -94,11 +94,11 @@
   if (mixdev < 0 || mixdev >= num_mixers)
     {
       cmn_err (CE_WARN, "Bad mixer device %d\n", mixdev);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (!mixer_devs[mixdev]->enabled || mixer_devs[mixdev]->unloaded)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (cmd == SOUND_MIXER_INFO)
     return get_mixer_info (mixdev, arg);
@@ -197,7 +197,7 @@
 
   n = buf->num;
   if (n < 0 || n >= num_mixer_volumes)
-    err = -EINVAL;
+    err = RETERR(EINVAL);
   else
     {
       memcpy ((char *) buf, (char *) &mixer_vols[n], sizeof (*buf));
@@ -226,17 +226,17 @@
   int extnr;
 
   if (ent == NULL)
-    return -EFAULT;
+    return RETERR(EFAULT);
 
   if (ent->dev < 0 || ent->dev >= num_mixers)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   dev = ent->dev;
   touch_mixer (dev);
 
   ctrl = ent->ctrl;
   if (ent->ctrl < 0 || ent->ctrl >= mixer_devs[dev]->nr_ext)
-    return -EIDRM;
+    return RETERR(EIDRM);
   extnr = ent->ctrl;
 
   memcpy ((char *) ent, (char *) &mixer_devs[dev]->extensions[extnr].ext,
@@ -263,7 +263,7 @@
   int dev, ctrl;
 
   if (ent == NULL)
-    return -EFAULT;
+    return RETERR(EFAULT);
 
   dev = ent->dev;
   ctrl = ent->ctrl;
@@ -271,19 +271,19 @@
 
   if (dev < 0 || dev >= num_mixers)
     {
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
 
   touch_mixer (dev);
 
   if (ctrl < 0 || ctrl >= mixer_devs[dev]->nr_ext)
     {
-      return -EIDRM;
+      return RETERR(EIDRM);
     }
 
   if (mixer_devs[dev]->extensions[ctrl].enum_info == NULL)
     {
-      return -EIO;
+      return RETERR(EIO);
     }
 
   memcpy ((char *) ent,
@@ -344,17 +344,17 @@
   int extnr;
 
   if (ent == NULL)
-    return -EFAULT;
+    return RETERR(EFAULT);
 
   if (ent->dev < 0 || ent->dev >= num_mixers)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   dev = ent->dev;
   touch_mixer (dev);
 
   ctrl = ent->ctrl;
   if (ent->ctrl < 0 || ent->ctrl >= mixer_devs[dev]->nr_ext)
-    return -EIDRM;
+    return RETERR(EIDRM);
   extnr = ent->ctrl;
 
   if (mixer_devs[dev]->extensions[extnr].enum_info == NULL)
@@ -362,7 +362,7 @@
       PMALLOC (mixer_devs[dev]->osdev, sizeof (*ent));
 
   if (mixer_devs[dev]->extensions[extnr].enum_info == NULL)
-    return -EIO;
+    return RETERR(EIO);
 
   memcpy ((char *) mixer_devs[dev]->extensions[extnr].enum_info,
 	  (char *) ent, sizeof (*ent));
@@ -375,7 +375,7 @@
   if (ent->nvalues >= OSS_ENUM_MAXVALUE)
     {
       mixer_devs[dev]->extensions[extnr].enum_info = NULL;
-      return -EIO;
+      return RETERR(EIO);
     }
 
   return 0;
@@ -392,19 +392,19 @@
   mixer_ext_fn func;
 
   if (val == NULL)
-    return -EFAULT;
+    return RETERR(EFAULT);
 
   if (val->dev < 0 || val->dev >= num_mixers)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   dev = val->dev;
 
   if (!mixer_devs[dev]->enabled || mixer_devs[dev]->unloaded)
-    return -ENXIO;
+    return RETERR(ENXIO);
   touch_mixer (dev);
 
   if (val->ctrl < 0 || val->ctrl >= mixer_devs[dev]->nr_ext)
-    return -EIDRM;
+    return RETERR(EIDRM);
   extnr = val->ctrl;
 
   ext_desc = &mixer_devs[dev]->extensions[extnr];
@@ -412,11 +412,11 @@
 
   if (val->timestamp != ext->timestamp)
     {
-      return -EIDRM;
+      return RETERR(EIDRM);
     }
 
   if (ext_desc->handler == NULL || !(ext->flags & MIXF_READABLE))
-    return -EFAULT;
+    return RETERR(EFAULT);
 
   func = (mixer_ext_fn) ext_desc->handler;
   return (val->value = func (dev, ext->ctrl, SNDCTL_MIX_READ, val->value));
@@ -436,19 +436,19 @@
   if (val == NULL)
     {
       cmn_err (CE_WARN, "NULL argument in mixer call\n");
-      return -EFAULT;
+      return RETERR(EFAULT);
     }
 
   if (val->dev < 0 || val->dev >= num_mixers)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   dev = val->dev;
   if (!mixer_devs[dev]->enabled || mixer_devs[dev]->unloaded)
-    return -ENXIO;
+    return RETERR(ENXIO);
   touch_mixer (dev);
 
   if (val->ctrl < 0 || val->ctrl >= mixer_devs[dev]->nr_ext)
-    return -EIDRM;
+    return RETERR(EIDRM);
   extnr = val->ctrl;
 
   ext_desc = &mixer_devs[dev]->extensions[extnr];
@@ -457,12 +457,12 @@
   if (ext_desc->handler == NULL || !(ext->flags & MIXF_WRITEABLE))
     {
       cmn_err (CE_WARN, "NULL handler or control not writeable\n");
-      return -EFAULT;
+      return RETERR(EFAULT);
     }
 
   if (val->timestamp != ext->timestamp)
     {
-      return -EIDRM;
+      return RETERR(EIDRM);
     }
 
   func = (mixer_ext_fn) ext_desc->handler;
@@ -489,7 +489,7 @@
   if (mixer_devs[dev]->max_ext != 0)
     {
       cmn_err (CE_WARN, "Mixer%d (ext) initialization order wrong\n", dev);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   mixext_desc =
@@ -498,7 +498,7 @@
   if (mixext_desc == NULL)
     {
       cmn_err (CE_CONT, "Not enough memory for mixer%d (ext)\n", dev);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   mixer_devs[dev]->extensions = mixext_desc;
@@ -544,14 +544,14 @@
     {
       cmn_err (CE_WARN, "Mixer extensions not initialized for device %d\n",
 	       dev);
-      return -EFAULT;
+      return RETERR(EFAULT);
     }
 
   if (mixer_devs[dev]->nr_ext >= mixer_devs[dev]->max_ext)
     {
       cmn_err (CE_WARN, "Out of mixer controls for device %d/%s (%d)\n", dev,
 	       mixer_devs[dev]->name, mixer_devs[dev]->max_ext);
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
 
   mixext_desc =
@@ -609,14 +609,14 @@
     {
       cmn_err (CE_WARN, "Mixer extensions not initialized for device %d\n",
 	       dev);
-      return -EFAULT;
+      return RETERR(EFAULT);
     }
 
   if (mixer_devs[dev]->nr_ext >= mixer_devs[dev]->max_ext)
     {
       cmn_err (CE_WARN, "Out of mixer controls for device %d/%s (%d)\n", dev,
 	       mixer_devs[dev]->name, mixer_devs[dev]->max_ext);
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
 
   if (func == NULL)		/* No access function */
@@ -728,7 +728,7 @@
       return value;
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 int
@@ -1104,7 +1104,7 @@
  * extended mixer is actually used.
  */
   if (dev < 0 || dev >= num_mixers)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   mixer_devs[dev]->nr_extra_ext = nextra;
   mixer_devs[dev]->create_controls = func;
@@ -1123,7 +1123,7 @@
  * extended mixer is actually used.
  */
   if (dev < 0 || dev >= num_mixers)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   mixer_devs[dev]->nr_extra_ext += nextra;
   mixer_devs[dev]->create_vmix_controls = func;
@@ -1249,16 +1249,16 @@
     case SNDCTL_MIX_NREXT:	/* Return # of mixer extensions for device */
       val = *arg;
       if (val < 0 || val >= num_mixers)
-	return -ENXIO;
+	return RETERR(ENXIO);
       if (mixer_devs[val] == NULL || mixer_devs[val]->unloaded
 	  || !mixer_devs[val]->enabled)
 	{
-	  return -ENXIO;
+	  return RETERR(ENXIO);
 	}
 
 
       if (!mixer_devs[val]->enabled || mixer_devs[val]->unloaded)
-	return -ENXIO;
+	return RETERR(ENXIO);
       touch_mixer (val);
       return *arg = (mixer_devs[val]->nr_ext);
       break;
@@ -1294,13 +1294,13 @@
 	adev_p adev;
 
 	if (info == NULL)
-	  return -EFAULT;
+	  return RETERR(EFAULT);
 
 	dev = info->dev;
 
 	if (dev < -1 || dev >= num_audio_devfiles)
 	  {
-	    return -EINVAL;
+	    return RETERR(EINVAL);
 	  }
 
 	if (dev >= 0)
@@ -1327,7 +1327,7 @@
 	adev_p adev, next;
 
 	if (info == NULL)
-	  return -EFAULT;
+	  return RETERR(EFAULT);
 
 	dev = info->dev;
 
@@ -1340,12 +1340,12 @@
 	      break;
 
 	    default:
-	      return -EINVAL;
+	      return RETERR(EINVAL);
 	    }
 
 	if (dev < 0 || dev >= num_audio_engines)
 	  {
-	    return -EINVAL;
+	    return RETERR(EINVAL);
 	  }
 
 	memset ((char *) info, 0, sizeof (*info));
@@ -1354,7 +1354,7 @@
 	if (adev == NULL)
 	  {
 	    cmn_err (CE_WARN, "Internal error - adev==NULL (%d)\n", dev);
-	    return -ENXIO;
+	    return RETERR(ENXIO);
 	  }
 
 	if (!adev->unloaded && adev->enabled)
@@ -1406,11 +1406,11 @@
 	  {
 	    if (audio_engines[dev]->d->ioctl (dev, SNDCTL_GETSONG,
 					      (ioctl_arg) info->song_name) ==
-		-EINVAL)
+		RETERR(EINVAL))
 	      strcpy (info->song_name, adev->song_name);
 	    if (audio_engines[dev]->d->ioctl (dev, SNDCTL_GETLABEL,
 					      (ioctl_arg) info->label) ==
-		-EINVAL)
+		RETERR(EINVAL))
 	      strcpy (info->label, adev->label);
 	  }
 
@@ -1496,19 +1496,19 @@
 	       */
 	      dev = orig_dev;
 	      if (dev < 0 || dev >= oss_num_midi_clients)
-		return -ENXIO;
+		return RETERR(ENXIO);
 	      if (oss_midi_clients[dev]->mididev == NULL)
-		return -EBUSY;	/* No binding established (yet) */
+		return RETERR(EBUSY);	/* No binding established (yet) */
 	      dev = oss_midi_clients[dev]->mididev->dev;
 	      break;
 
 	    default:
-	      return -EINVAL;
+	      return RETERR(EINVAL);
 	    }
 
 	if (dev < 0 || dev >= num_mididevs)
 	  {
-	    return -EINVAL;
+	    return RETERR(EINVAL);
 	  }
 
 	memset ((char *) info, 0, sizeof (*info));
@@ -1574,7 +1574,7 @@
 
 	if (card < 0 || card >= oss_num_cards)
 	  {
-	    return -ENXIO;
+	    return RETERR(ENXIO);
 	  }
 
 	memset ((char *) info, 0, sizeof (*info));
@@ -1602,16 +1602,16 @@
 	      break;
 
 	    default:
-	      return -EINVAL;
+	      return RETERR(EINVAL);
 	    }
 
 	if (dev < 0 || dev >= num_mixers)
 	  {
-	    return -EINVAL;
+	    return RETERR(EINVAL);
 	  }
 
 	if (mixer_devs[dev] == NULL)
-	  return -ENXIO;
+	  return RETERR(ENXIO);
 
 	memset ((char *) info, 0, sizeof (*info));
 	touch_mixer (dev);
@@ -1642,13 +1642,13 @@
 	int i;
 
 	if (GET_PROCESS_UID () != 0)	/* Not root */
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 
 	if (r->n != num_audio_devfiles)	/* Wrong map size? */
 	  {
 	    cmn_err (CE_NOTE, "Legacy audio map size mismatch %d/%d\n",
 		     r->n, num_audio_devfiles);
-	    return -EINVAL;
+	    return RETERR(EINVAL);
 	  }
 
 	for (i = 0; i < r->n; i++)
@@ -1656,7 +1656,7 @@
 	    adev_p adev = audio_devfiles[i];
 
 	    if (r->map[i] >= OSS_MAX_CDEVS)	/* May be unnecessary check */
-	      return -EINVAL;
+	      return RETERR(EINVAL);
 
 	    if (r->map[i] < -1)
 	      r->map[i] = -1;
@@ -1673,17 +1673,17 @@
 	int i;
 
 	if (GET_PROCESS_UID () != 0)	/* Not root */
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 
 	if (r->n != num_mixers)	/* Wrong map size? */
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 
 	for (i = 0; i < r->n; i++)
 	  {
 	    mixdev_p mdev = mixer_devs[i];
 
 	    if (r->map[i] >= OSS_MAX_CDEVS)	/* May be unnecessary check */
-	      return -EINVAL;
+	      return RETERR(EINVAL);
 
 	    mdev->real_dev = r->map[i];
 	  }
@@ -1697,17 +1697,17 @@
 	int i;
 
 	if (GET_PROCESS_UID () != 0)	/* Not root */
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 
 	if (r->n != num_mididevs)	/* Wrong map size? */
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 
 	for (i = 0; i < r->n; i++)
 	  {
 	    mididev_p mdev = midi_devs[i];
 
 	    if (r->map[i] >= OSS_MAX_CDEVS)	/* May be unnecessary check */
-	      return -EINVAL;
+	      return RETERR(EINVAL);
 
 	    mdev->real_dev = r->map[i];
 	  }
@@ -1721,7 +1721,7 @@
 
 	if (GET_PROCESS_UID () != 0)	/* Not root */
 	  {
-	    return -EINVAL;
+	    return RETERR(EINVAL);
 	  }
 
 	switch (r->mode)
@@ -1742,7 +1742,7 @@
 	    break;
 
 	  default:
-	    return -EINVAL;
+	    return RETERR(EINVAL);
 	  }
       }
       return 0;
@@ -1754,12 +1754,12 @@
 	int i, d;
 
 	if (GET_PROCESS_UID () != 0)	/* Not root */
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 
 	for (i = 0; i < r->devlist.ndevs; i++)
 	  {
 	    if ((d = r->devlist.devices[i]) < 0 || d >= num_audio_devfiles)
-	      return -EINVAL;
+	      return RETERR(EINVAL);
 	  }
 
 	switch (r->mode)
@@ -1768,7 +1768,7 @@
 	    /* Refuse if number of devices has changed */
 	    if (!check_list (&r->devlist, &dspinlist))
 	      {
-		return -EINVAL;
+		return RETERR(EINVAL);
 	      }
 	    memcpy (&dspinlist, &r->devlist, sizeof (oss_devlist_t));
 	    break;
@@ -1780,7 +1780,7 @@
 	    /* Refuse if number of devices has changed */
 	    if (!check_list (&r->devlist, &dspoutlist))
 	      {
-		return -EINVAL;
+		return RETERR(EINVAL);
 	      }
 	    memcpy (&dspoutlist, &r->devlist, sizeof (oss_devlist_t));
 	    dspoutlist2.ndevs = 0;
@@ -1790,13 +1790,13 @@
 	    /* Refuse if number of devices has changed */
 	    if (!check_list (&r->devlist, &dspinoutlist))
 	      {
-		return -EINVAL;
+		return RETERR(EINVAL);
 	      }
 	    memcpy (&dspinoutlist, &r->devlist, sizeof (oss_devlist_t));
 	    break;
 
 	  default:
-	    return -EINVAL;
+	    return RETERR(EINVAL);
 	  }
       }
       return 0;
@@ -1805,7 +1805,7 @@
 #ifdef APPLIST_SUPPORT
     case OSSCTL_RESET_APPLIST:
       if (GET_PROCESS_UID () != 0)	/* Not root */
-	return -EINVAL;
+	return RETERR(EINVAL);
 
       oss_applist_size = 0;
       return 0;
@@ -1816,13 +1816,13 @@
 	app_routing_t *def, *parm = (app_routing_t *) arg;
 
 	if (GET_PROCESS_UID () != 0)	/* Not root */
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 
 	if (oss_applist_size >= APPLIST_SIZE)
-	  return -ENOSPC;
+	  return RETERR(ENOSPC);
 
 	if (parm->dev < -1 || parm->dev >= num_audio_devfiles)
-	  return -ENXIO;
+	  return RETERR(ENXIO);
 
 	def = &oss_applist[oss_applist_size];
 
@@ -1839,7 +1839,7 @@
 #endif
 
     default:
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 }
 
@@ -1859,10 +1859,10 @@
     return 0;
 
   if (mixer_devs[dev]->unloaded)
-    return -ENODEV;
+    return RETERR(ENODEV);
 
   if (!mixer_devs[dev]->enabled)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   return 0;
 }
@@ -1879,15 +1879,15 @@
   int ret;
 
   if (dev < 0 || dev > num_mixers)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (mixer_devs == NULL)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (!mixer_devs[dev]->enabled || mixer_devs[dev]->unloaded)
-    return -ENODEV;
+    return RETERR(ENODEV);
 
-  if ((ret = oss_legacy_mixer_ioctl (dev, -1, cmd, arg)) != -EINVAL)
+  if ((ret = oss_legacy_mixer_ioctl (dev, -1, cmd, arg)) != RETERR(EINVAL))
     return ret;
 
   return oss_mixer_ext (dev, OSS_DEV_MIXER, cmd, arg);
@@ -2152,13 +2152,13 @@
 	       num_mixers, MAX_MIXER_DEV, name);
       if (nnn > 10)
 	cmn_err (CE_PANIC, "Giving up\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (vers != OSS_MIXER_DRIVER_VERSION)
     {
       cmn_err (CE_WARN, "Incompatible mixer driver for %s\n", name);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (driver_size > sizeof (mixer_driver_t))
@@ -2182,7 +2182,7 @@
   if ((d = PMALLOC (osdev, sizeof (*d))) == NULL)
     {
       cmn_err (CE_WARN, "Can't allocate mixer driver for (%s)\n", name);
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
 
   if (num == -1)
@@ -2191,7 +2191,7 @@
       if (op == NULL)
 	{
 	  cmn_err (CE_WARN, "Can't allocate mixer driver for (%s)\n", name);
-	  return -ENOSPC;
+	  return RETERR(ENOSPC);
 	}
 
       num = num_mixers++;
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/ossddk/ossddk.c oss-v4.1test0-070624-src-gpl/kernel/framework/ossddk/ossddk.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/ossddk/ossddk.c	Sun Jun 24 18:09:42 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/ossddk/ossddk.c	Tue Jun 26 22:19:45 2007
@@ -453,7 +453,7 @@
   *handle = NULL;
 
   if ((h = KERNEL_MALLOC (sizeof (*h))) == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
 
   if ((err =
        ac97_install (&h->devc, name, readfn, writefn, hostparms, osdev)) < 0)
